"""
    Ryax API for all services

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)  # noqa: E501

    The version of the OpenAPI document: 23.05.0
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from ryax_sdk.api_client import ApiClient, Endpoint as _Endpoint
from ryax_sdk.model_utils import (  # noqa: F401
    check_allowed_values,
    check_validations,
    date,
    datetime,
    file_type,
    none_type,
    validate_and_convert_types
)
from ryax_sdk.model.runner_error import RunnerError
from ryax_sdk.model.runner_workflow_run import RunnerWorkflowRun
from ryax_sdk.model.runner_workflow_run_schema_minimal import RunnerWorkflowRunSchemaMinimal
from ryax_sdk.model.runner_workflow_run_trigger_response import RunnerWorkflowRunTriggerResponse


class ExecutionsApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

        def __runner_portals_workflow_definition_id_post(
            self,
            workflow_definition_id,
            **kwargs
        ):
            """Trigger a new workflow run  # noqa: E501

            Await a multipart, where each part is named after an input and contains the data.  # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.runner_portals_workflow_definition_id_post(workflow_definition_id, async_req=True)
            >>> result = thread.get()

            Args:
                workflow_definition_id (str):

            Keyword Args:
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (float/tuple): timeout setting for this request. If one
                    number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                RunnerWorkflowRunTriggerResponse
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['workflow_definition_id'] = \
                workflow_definition_id
            return self.call_with_http_info(**kwargs)

        self.runner_portals_workflow_definition_id_post = _Endpoint(
            settings={
                'response_type': (RunnerWorkflowRunTriggerResponse,),
                'auth': [
                    'bearer'
                ],
                'endpoint_path': '/runner/portals/{workflow_definition_id}',
                'operation_id': 'runner_portals_workflow_definition_id_post',
                'http_method': 'POST',
                'servers': None,
            },
            params_map={
                'all': [
                    'workflow_definition_id',
                ],
                'required': [
                    'workflow_definition_id',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'workflow_definition_id':
                        (str,),
                },
                'attribute_map': {
                    'workflow_definition_id': 'workflow_definition_id',
                },
                'location_map': {
                    'workflow_definition_id': 'path',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client,
            callable=__runner_portals_workflow_definition_id_post
        )

        def __runner_workflow_runs_get(
            self,
            **kwargs
        ):
            """List workflow runs  # noqa: E501

            List workflow runs.  # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.runner_workflow_runs_get(async_req=True)
            >>> result = thread.get()


            Keyword Args:
                workflow_id (str): [optional]
                range (str): [optional]
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (float/tuple): timeout setting for this request. If one
                    number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                [RunnerWorkflowRunSchemaMinimal]
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            return self.call_with_http_info(**kwargs)

        self.runner_workflow_runs_get = _Endpoint(
            settings={
                'response_type': ([RunnerWorkflowRunSchemaMinimal],),
                'auth': [
                    'bearer'
                ],
                'endpoint_path': '/runner/workflow_runs',
                'operation_id': 'runner_workflow_runs_get',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'workflow_id',
                    'range',
                ],
                'required': [],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'workflow_id':
                        (str,),
                    'range':
                        (str,),
                },
                'attribute_map': {
                    'workflow_id': 'workflow_id',
                    'range': 'range',
                },
                'location_map': {
                    'workflow_id': 'query',
                    'range': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client,
            callable=__runner_workflow_runs_get
        )

        def __runner_workflow_runs_workflow_run_id_delete(
            self,
            workflow_run_id,
            **kwargs
        ):
            """Delete a workflow run  # noqa: E501

            Delete a workflow run by its id. Deletes all execution results and connections belonging to that workflow run.  # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.runner_workflow_runs_workflow_run_id_delete(workflow_run_id, async_req=True)
            >>> result = thread.get()

            Args:
                workflow_run_id (str):

            Keyword Args:
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (float/tuple): timeout setting for this request. If one
                    number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                None
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['workflow_run_id'] = \
                workflow_run_id
            return self.call_with_http_info(**kwargs)

        self.runner_workflow_runs_workflow_run_id_delete = _Endpoint(
            settings={
                'response_type': None,
                'auth': [
                    'bearer'
                ],
                'endpoint_path': '/runner/workflow_runs/{workflow_run_id}',
                'operation_id': 'runner_workflow_runs_workflow_run_id_delete',
                'http_method': 'DELETE',
                'servers': None,
            },
            params_map={
                'all': [
                    'workflow_run_id',
                ],
                'required': [
                    'workflow_run_id',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'workflow_run_id':
                        (str,),
                },
                'attribute_map': {
                    'workflow_run_id': 'workflow_run_id',
                },
                'location_map': {
                    'workflow_run_id': 'path',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client,
            callable=__runner_workflow_runs_workflow_run_id_delete
        )

        def __runner_workflow_runs_workflow_run_id_get(
            self,
            workflow_run_id,
            **kwargs
        ):
            """Get a workflow run  # noqa: E501

            Get one complete workflow run from its id.  # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.runner_workflow_runs_workflow_run_id_get(workflow_run_id, async_req=True)
            >>> result = thread.get()

            Args:
                workflow_run_id (str):

            Keyword Args:
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (float/tuple): timeout setting for this request. If one
                    number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                RunnerWorkflowRun
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['workflow_run_id'] = \
                workflow_run_id
            return self.call_with_http_info(**kwargs)

        self.runner_workflow_runs_workflow_run_id_get = _Endpoint(
            settings={
                'response_type': (RunnerWorkflowRun,),
                'auth': [
                    'bearer'
                ],
                'endpoint_path': '/runner/workflow_runs/{workflow_run_id}',
                'operation_id': 'runner_workflow_runs_workflow_run_id_get',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'workflow_run_id',
                ],
                'required': [
                    'workflow_run_id',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'workflow_run_id':
                        (str,),
                },
                'attribute_map': {
                    'workflow_run_id': 'workflow_run_id',
                },
                'location_map': {
                    'workflow_run_id': 'path',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client,
            callable=__runner_workflow_runs_workflow_run_id_get
        )
